#!/usr/bin/perl -w
#
#Add file area descriptions from the FDN list into your 
#BBBS filedirg.000 file. 
#
#Edit the top of the script to configure it.
#
#Requires: Perl 5.x. 
#
#Tested on: Redhat Linux 7.0 
#
#Author - Russ Johnson
#Released under version 2 of the GPL.
#Initial release, version 1.0, 8/22/2001

# Description file
$echodescfile = "/home/ftp/pub/fg_worf/FILEGATE.ZXX";

# Location of filedirg.000
$filedirg = "/home/bbbs/filedirg.000";

# Description used in new file areas
$newdesc = "New File Area";

#######################################
# Don't modify below this line
#######################################

use File::Copy;

&readfile();

&writefile();

&cleanup();


#######################################
# Subroutines
#######################################

sub readfile
{
	open (FILE, "$filedirg") || die "$0: Failed to open $filedirg: $!";
	open (TEMPFILE, ">$0.$$") || die "$0: Failed to open $0.$$: $!";
	
	while (<FILE>)
	{
		chomp;
		
		if ($_ =~ /$newdesc$/)
		{
			$_ =~ s/$newdesc//;
			
			$line = $_;
			
			$area = substr $_, 1, 15;
			$area =~ tr/a-z/A-Z/;
			$area =~ s/ //g;
			
			&areadescription($area);
			
			if (!defined $echodesc || $echodesc eq "")
			{
				print TEMPFILE "$line", "No Description Available\n";
			}
			else
			{
				print TEMPFILE "$line", "$echodesc\n";
			}
		}
		else
		{
			print TEMPFILE "$_\n";
		}
	}
	
	close (TEMPFILE);
	close (FILE);
}

#######################################
# Move newfile to live location
#######################################

sub writefile
{
	unlink "$filedirg";
	copy("$0.$$", "$filedirg");
}

#######################################
# Get area description
# Required parameters: area to look for
#######################################

sub areadescription
{
	if (defined $echodescfile)
	{
		open(DESC, "$echodescfile") || die "Can't open $echodescfile: $!";
		
		while (<DESC>)
		{
			chomp;
			
			if (/$_[0]/i && !/^%/)
			{
				$startdesc = (rindex $_, "  " ) + 2;
				
				$echodesc = substr($_, $startdesc);
			}
		}
		
		close(DESC);
	}
}

#######################################
# Clean up the mess
#######################################

sub cleanup
{
	unlink "$0.$$";
}